/* http://keith-wood.name/countdown.html
   Countdown for jQuery v1.5.11.
   Written by Keith Wood (kbwood{at}iinet.com.au) January 2008.
   Dual licensed under the GPL (http://dev.jquery.com/browser/trunk/jquery/GPL-LICENSE.txt) and 
   MIT (http://dev.jquery.com/browser/trunk/jquery/MIT-LICENSE.txt) licenses. 
   Please attribute the author if you use it. *//* Display a countdown timer.
   Attach it with options like:
   $('div selector').countdown(
       {until: new Date(2009, 1 - 1, 1, 0, 0, 0), onExpiry: happyNewYear}); */(function(e){function t(){function t(i){var s=i||(new Date).getTime();s-r>=1e3&&(e.countdown._updateTargets(),r=s),n(t)}this.regional=[],this.regional[""]={labels:["Years","Months","Weeks","Days","Hours","Minutes","Seconds"],labels1:["Year","Month","Week","Day","Hour","Minute","Second"],compactLabels:["y","m","w","d"],whichLabels:null,timeSeparator:":",isRTL:!1},this._defaults={until:null,since:null,timezone:null,serverSync:null,format:"dHMS",layout:"",compact:!1,significant:0,description:"",expiryUrl:"",expiryText:"",alwaysExpire:!1,onExpiry:null,onTick:null,tickInterval:1},e.extend(this._defaults,this.regional[""]),this._serverSyncs=[];var n=window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||null,r=0;n?(r=window.mozAnimationStartTime||(new Date).getTime(),n(t)):setInterval(function(){e.countdown._updateTargets()},980)}function l(t,n){e.extend(t,n);for(var r in n)n[r]==null&&(t[r]=null);return t}var n="countdown",r=0,i=1,s=2,o=3,u=4,a=5,f=6;e.extend(t.prototype,{markerClassName:"hasCountdown",_timerTargets:[],setDefaults:function(e){this._resetExtraLabels(this._defaults,e),l(this._defaults,e||{})},UTCDate:function(e,t,n,r,i,s,o,u){typeof t=="object"&&t.constructor==Date&&(u=t.getMilliseconds(),o=t.getSeconds(),s=t.getMinutes(),i=t.getHours(),r=t.getDate(),n=t.getMonth(),t=t.getFullYear());var a=new Date;return a.setUTCFullYear(t),a.setUTCDate(1),a.setUTCMonth(n||0),a.setUTCDate(r||1),a.setUTCHours(i||0),a.setUTCMinutes((s||0)-(Math.abs(e)<30?e*60:e)),a.setUTCSeconds(o||0),a.setUTCMilliseconds(u||0),a},periodsToSeconds:function(e){return e[0]*31557600+e[1]*2629800+e[2]*604800+e[3]*86400+e[4]*3600+e[5]*60+e[6]},_settingsCountdown:function(t,r){if(!r)return e.countdown._defaults;var i=e.data(t,n);return r=="all"?i.options:i.options[r]},_attachCountdown:function(t,r){var i=e(t);if(i.hasClass(this.markerClassName))return;i.addClass(this.markerClassName);var s={options:e.extend({},r),_periods:[0,0,0,0,0,0,0]};e.data(t,n,s),this._changeCountdown(t)},_addTarget:function(e){this._hasTarget(e)||this._timerTargets.push(e)},_hasTarget:function(t){return e.inArray(t,this._timerTargets)>-1},_removeTarget:function(t){this._timerTargets=e.map(this._timerTargets,function(e){return e==t?null:e})},_updateTargets:function(){for(var e=this._timerTargets.length-1;e>=0;e--)this._updateCountdown(this._timerTargets[e])},_updateCountdown:function(t,r){var i=e(t);r=r||e.data(t,n);if(!r)return;i.html(this._generateHTML(r)),i[(this._get(r,"isRTL")?"add":"remove")+"Class"]("countdown_rtl");var s=this._get(r,"onTick");if(s){var o=r._hold!="lap"?r._periods:this._calculatePeriods(r,r._show,this._get(r,"significant"),new Date),u=this._get(r,"tickInterval");(u==1||this.periodsToSeconds(o)%u==0)&&s.apply(t,[o])}var a=r._hold!="pause"&&(r._since?r._now.getTime()<r._since.getTime():r._now.getTime()>=r._until.getTime());if(a&&!r._expiring){r._expiring=!0;if(this._hasTarget(t)||this._get(r,"alwaysExpire")){this._removeTarget(t);var f=this._get(r,"onExpiry");f&&f.apply(t,[]);var l=this._get(r,"expiryText");if(l){var c=this._get(r,"layout");r.options.layout=l,this._updateCountdown(t,r),r.options.layout=c}var h=this._get(r,"expiryUrl");h&&(window.location=h)}r._expiring=!1}else r._hold=="pause"&&this._removeTarget(t);e.data(t,n,r)},_changeCountdown:function(t,r,i){r=r||{};if(typeof r=="string"){var s=r;r={},r[s]=i}var o=e.data(t,n);if(o){this._resetExtraLabels(o.options,r),l(o.options,r),this._adjustSettings(t,o),e.data(t,n,o);var u=new Date;(o._since&&o._since<u||o._until&&o._until>u)&&this._addTarget(t),this._updateCountdown(t,o)}},_resetExtraLabels:function(e,t){var n=!1;for(var r in t)if(r!="whichLabels"&&r.match(/[Ll]abels/)){n=!0;break}if(n)for(var r in e)r.match(/[Ll]abels[0-9]/)&&(e[r]=null)},_adjustSettings:function(e,t){var n,r=this._get(t,"serverSync"),i=0,s=null;for(var o=0;o<this._serverSyncs.length;o++)if(this._serverSyncs[o][0]==r){s=this._serverSyncs[o][1];break}if(s!=null)i=r?s:0,n=new Date;else{var u=r?r.apply(e,[]):null;n=new Date,i=u?n.getTime()-u.getTime():0,this._serverSyncs.push([r,i])}var a=this._get(t,"timezone");a=a==null?-n.getTimezoneOffset():a,t._since=this._get(t,"since"),t._since!=null&&(t._since=this.UTCDate(a,this._determineTime(t._since,null)),t._since&&i&&t._since.setMilliseconds(t._since.getMilliseconds()+i)),t._until=this.UTCDate(a,this._determineTime(this._get(t,"until"),n)),i&&t._until.setMilliseconds(t._until.getMilliseconds()+i),t._show=this._determineShow(t)},_destroyCountdown:function(t){var r=e(t);if(!r.hasClass(this.markerClassName))return;this._removeTarget(t),r.removeClass(this.markerClassName).empty(),e.removeData(t,n)},_pauseCountdown:function(e){this._hold(e,"pause")},_lapCountdown:function(e){this._hold(e,"lap")},_resumeCountdown:function(e){this._hold(e,null)},_hold:function(t,r){var i=e.data(t,n);if(i){if(i._hold=="pause"&&!r){i._periods=i._savePeriods;var s=i._since?"-":"+";i[i._since?"_since":"_until"]=this._determineTime(s+i._periods[0]+"y"+s+i._periods[1]+"o"+s+i._periods[2]+"w"+s+i._periods[3]+"d"+s+i._periods[4]+"h"+s+i._periods[5]+"m"+s+i._periods[6]+"s"),this._addTarget(t)}i._hold=r,i._savePeriods=r=="pause"?i._periods:null,e.data(t,n,i),this._updateCountdown(t,i)}},_getTimesCountdown:function(t){var r=e.data(t,n);return r?r._hold?this._calculatePeriods(r,r._show,this._get(r,"significant"),new Date):r._periods:null},_get:function(t,n){return t.options[n]!=null?t.options[n]:e.countdown._defaults[n]},_determineTime:function(t,n){var r=function(e){var t=new Date;return t.setTime(t.getTime()+e*1e3),t},i=function(t){t=t.toLowerCase();var n=new Date,r=n.getFullYear(),i=n.getMonth(),s=n.getDate(),o=n.getHours(),u=n.getMinutes(),a=n.getSeconds(),f=/([+-]?[0-9]+)\s*(s|m|h|d|w|o|y)?/g,l=f.exec(t);while(l){switch(l[2]||"s"){case"s":a+=parseInt(l[1],10);break;case"m":u+=parseInt(l[1],10);break;case"h":o+=parseInt(l[1],10);break;case"d":s+=parseInt(l[1],10);break;case"w":s+=parseInt(l[1],10)*7;break;case"o":i+=parseInt(l[1],10),s=Math.min(s,e.countdown._getDaysInMonth(r,i));break;case"y":r+=parseInt(l[1],10),s=Math.min(s,e.countdown._getDaysInMonth(r,i))}l=f.exec(t)}return new Date(r,i,s,o,u,a,0)},s=t==null?n:typeof t=="string"?i(t):typeof t=="number"?r(t):t;return s&&s.setMilliseconds(0),s},_getDaysInMonth:function(e,t){return 32-(new Date(e,t,32)).getDate()},_normalLabels:function(e){return e},_generateHTML:function(t){var n=this._get(t,"significant");t._periods=t._hold?t._periods:this._calculatePeriods(t,t._show,n,new Date);var l=!1,c=0,h=n,p=e.extend({},t._show);for(var d=r;d<=f;d++)l|=t._show[d]=="?"&&t._periods[d]>0,p[d]=t._show[d]=="?"&&!l?null:t._show[d],c+=p[d]?1:0,h-=t._periods[d]>0?1:0;var v=[!1,!1,!1,!1,!1,!1,!1];for(var d=f;d>=r;d--)t._show[d]&&(t._periods[d]?v[d]=!0:(v[d]=h>0,h--));var m=this._get(t,"compact"),g=this._get(t,"layout"),y=m?this._get(t,"compactLabels"):this._get(t,"labels"),b=this._get(t,"whichLabels")||this._normalLabels,w=this._get(t,"timeSeparator"),E=this._get(t,"description")||"",x=function(n){var r=e.countdown._get(t,"compactLabels"+b(t._periods[n]));return p[n]?t._periods[n]+(r?r[n]:y[n])+" ":""},T=function(r){var i=e.countdown._get(t,"labels"+b(t._periods[r]));return!n&&p[r]||n&&v[r]?'<span class="countdown_section"><span class="countdown_amount">'+t._periods[r]+"</span><br/>"+(i?i[r]:y[r])+"</span>":""};return g?this._buildLayout(t,p,g,m,n,v):(m?'<span class="countdown_row countdown_amount'+(t._hold?" countdown_holding":"")+'">'+x(r)+x(i)+x(s)+x(o)+(p[u]?this._minDigits(t._periods[u],2):"")+(p[a]?(p[u]?w:"")+this._minDigits(t._periods[a],2):"")+(p[f]?(p[u]||p[a]?w:"")+this._minDigits(t._periods[f],2):""):'<span class="countdown_row countdown_show'+(n||c)+(t._hold?" countdown_holding":"")+'">'+T(r)+T(i)+T(s)+T(o)+T(u)+T(a)+T(f))+"</span>"+(E?'<span class="countdown_row countdown_descr">'+E+"</span>":"")},_buildLayout:function(t,n,l,c,h,p){var d=this._get(t,c?"compactLabels":"labels"),v=this._get(t,"whichLabels")||this._normalLabels,m=function(n){return(e.countdown._get(t,(c?"compactLabels":"labels")+v(t._periods[n]))||d)[n]},g=function(e,t){return Math.floor(e/t)%10},y={desc:this._get(t,"description"),sep:this._get(t,"timeSeparator"),yl:m(r),yn:t._periods[r],ynn:this._minDigits(t._periods[r],2),ynnn:this._minDigits(t._periods[r],3),y1:g(t._periods[r],1),y10:g(t._periods[r],10),y100:g(t._periods[r],100),y1000:g(t._periods[r],1e3),ol:m(i),on:t._periods[i],onn:this._minDigits(t._periods[i],2),onnn:this._minDigits(t._periods[i],3),o1:g(t._periods[i],1),o10:g(t._periods[i],10),o100:g(t._periods[i],100),o1000:g(t._periods[i],1e3),wl:m(s),wn:t._periods[s],wnn:this._minDigits(t._periods[s],2),wnnn:this._minDigits(t._periods[s],3),w1:g(t._periods[s],1),w10:g(t._periods[s],10),w100:g(t._periods[s],100),w1000:g(t._periods[s],1e3),dl:m(o),dn:t._periods[o],dnn:this._minDigits(t._periods[o],2),dnnn:this._minDigits(t._periods[o],3),d1:g(t._periods[o],1),d10:g(t._periods[o],10),d100:g(t._periods[o],100),d1000:g(t._periods[o],1e3),hl:m(u),hn:t._periods[u],hnn:this._minDigits(t._periods[u],2),hnnn:this._minDigits(t._periods[u],3),h1:g(t._periods[u],1),h10:g(t._periods[u],10),h100:g(t._periods[u],100),h1000:g(t._periods[u],1e3),ml:m(a),mn:t._periods[a],mnn:this._minDigits(t._periods[a],2),mnnn:this._minDigits(t._periods[a],3),m1:g(t._periods[a],1),m10:g(t._periods[a],10),m100:g(t._periods[a],100),m1000:g(t._periods[a],1e3),sl:m(f),sn:t._periods[f],snn:this._minDigits(t._periods[f],2),snnn:this._minDigits(t._periods[f],3),s1:g(t._periods[f],1),s10:g(t._periods[f],10),s100:g(t._periods[f],100),s1000:g(t._periods[f],1e3)},b=l;for(var w=r;w<=f;w++){var E="yowdhms".charAt(w),x=new RegExp("\\{"+E+"<\\}(.*)\\{"+E+">\\}","g");b=b.replace(x,!h&&n[w]||h&&p[w]?"$1":"")}return e.each(y,function(e,t){var n=new RegExp("\\{"+e+"\\}","g");b=b.replace(n,t)}),b},_minDigits:function(e,t){return e=""+e,e.length>=t?e:(e="0000000000"+e,e.substr(e.length-t))},_determineShow:function(e){var t=this._get(e,"format"),n=[];return n[r]=t.match("y")?"?":t.match("Y")?"!":null,n[i]=t.match("o")?"?":t.match("O")?"!":null,n[s]=t.match("w")?"?":t.match("W")?"!":null,n[o]=t.match("d")?"?":t.match("D")?"!":null,n[u]=t.match("h")?"?":t.match("H")?"!":null,n[a]=t.match("m")?"?":t.match("M")?"!":null,n[f]=t.match("s")?"?":t.match("S")?"!":null,n},_calculatePeriods:function(t,n,l,c){t._now=c,t._now.setMilliseconds(0);var h=new Date(t._now.getTime());t._since?c.getTime()<t._since.getTime()?t._now=c=h:c=t._since:(h.setTime(t._until.getTime()),c.getTime()>t._until.getTime()&&(t._now=c=h));var p=[0,0,0,0,0,0,0];if(n[r]||n[i]){var d=e.countdown._getDaysInMonth(c.getFullYear(),c.getMonth()),v=e.countdown._getDaysInMonth(h.getFullYear(),h.getMonth()),m=h.getDate()==c.getDate()||h.getDate()>=Math.min(d,v)&&c.getDate()>=Math.min(d,v),g=function(e){return(e.getHours()*60+e.getMinutes())*60+e.getSeconds()},y=Math.max(0,(h.getFullYear()-c.getFullYear())*12+h.getMonth()-c.getMonth()+(h.getDate()<c.getDate()&&!m||m&&g(h)<g(c)?-1:0));p[r]=n[r]?Math.floor(y/12):0,p[i]=n[i]?y-p[r]*12:0,c=new Date(c.getTime());var b=c.getDate()==d,w=e.countdown._getDaysInMonth(c.getFullYear()+p[r],c.getMonth()+p[i]);c.getDate()>w&&c.setDate(w),c.setFullYear(c.getFullYear()+p[r]),c.setMonth(c.getMonth()+p[i]),b&&c.setDate(w)}var E=Math.floor((h.getTime()-c.getTime())/1e3),x=function(e,t){p[e]=n[e]?Math.floor(E/t):0,E-=p[e]*t};x(s,604800),x(o,86400),x(u,3600),x(a,60),x(f,1);if(E>0&&!t._since){var T=[1,12,4.3482,7,24,60,60],N=f,C=1;for(var k=f;k>=r;k--)n[k]&&(p[N]>=C&&(p[N]=0,E=1),E>0&&(p[k]++,E=0,N=k,C=1)),C*=T[k]}if(l)for(var k=r;k<=f;k++)l&&p[k]?l--:l||(p[k]=0);return p}}),e.fn.countdown=function(t){var n=Array.prototype.slice.call(arguments,1);return t=="getTimes"||t=="settings"?e.countdown["_"+t+"Countdown"].apply(e.countdown,[this[0]].concat(n)):this.each(function(){typeof t=="string"?e.countdown["_"+t+"Countdown"].apply(e.countdown,[this].concat(n)):e.countdown._attachCountdown(this,t)})},e.countdown=new t})(jQuery);